#ifndef debugdumpH
#define debugdumpH

#define DEBUGDUMP_ENABLE        0

#if !DEBUGDUMP_ENABLE
#define DEBUGDUMP(data, size, comment)
#else
#define DEBUGDUMP(data, size, comment) g_DebugDump.Dump((data), (size), (comment))

#include <windows.h>
#include <stdio.h>
#include "critical.h"

/*================================================================================================*/
class TDebugDump
    {
private:
    TCritical cs;
    FILE* f;
public:
    TDebugDump() : f(NULL)
        { }
    ~TDebugDump()
        { if (f) fclose(f); }
    void Dump(LPCVOID Data, DWORD DataSize, LPCSTR Comment);
    };
/*================================================================================================*/
extern TDebugDump g_DebugDump;

#endif // !DEBUGDUMP_ENABLE

#endif
