//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "DialogAddIP.h"
#include "common.h"
#include "stringres.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormAddIPDialog *FormAddIPDialog;
//---------------------------------------------------------------------------
__fastcall TFormAddIPDialog::TFormAddIPDialog(TComponent* Owner)
    : TForm(Owner), IP_Addr(0), IP_Flags(0)
    {
    }
//---------------------------------------------------------------------------
void __fastcall TFormAddIPDialog::FormShow(TObject *Sender)
    {
    /*    */
    if (IP_Addr)
        { //  
        Caption = LoadStr(IDS_dlgcap_ChangeIP);
        ButtonAdd->Caption = LoadStr(IDS_btncap_Change);
        EditIP->Text = IPToStr(IP_Addr);
        ButtonAdd->Enabled = true;
        CheckBoxAutoConnect->Checked = ((IP_Flags & CRATE_IP_FLAG_AUTOCONNECT) != 0);
        }
    else
        { //   (     )
        Caption = LoadStr(IDS_dlgcap_AddIP);
        ButtonAdd->Caption = LoadStr(IDS_btncap_Add);
        EditIP->Text = "";
        ButtonAdd->Enabled = false;
        IP_Flags = (CheckBoxAutoConnect->Checked) ? CRATE_IP_FLAG_AUTOCONNECT : 0;
        }

    LabelIP->Caption = LoadStr(IDS_lblcap_IPAddress);
    CheckBoxConnectNow->Caption = LoadStr(IDS_cbcap_ConnectNow);
    CheckBoxAutoConnect->Caption = LoadStr(IDS_cbcap_ConnectAtStartup);
    ButtonCancel->Caption = LoadStr(IDS_btncap_Cancel);
    }
//---------------------------------------------------------------------------
void __fastcall TFormAddIPDialog::EditIPChange(TObject *Sender)
    {
    /*    */
    IP_Addr = StrToIP(EditIP->Text.Trim());
    if (IP_Addr)
        {
        ButtonAdd->Enabled = true;
        EditIP->Font->Color = clWindowText;
        }
    else
        {
        ButtonAdd->Enabled = false;
        EditIP->Font->Color = clRed;
        }
    }
//---------------------------------------------------------------------------
void __fastcall TFormAddIPDialog::ButtonAddClick(TObject *Sender)
    {
    //    
    IP_Flags = (CheckBoxAutoConnect->Checked) ? CRATE_IP_FLAG_AUTOCONNECT : 0;
    }
//---------------------------------------------------------------------------

