#ifndef LtrCrateThreadsH
#define LtrCrateThreadsH

#include "LtrCrate.h"

//---------------------------------------------------------------------------
struct CRATE_REQUEST
    {
    DWORD *buf;
    OVERLAPPED over;
    };
//---------------------------------------------------------------------------
class TReadUSBCrateThread : public TThread
    {
private:
    TCrateUSB *crate;
    //          ,   DWORD
    DWORD dwReadBuf[CRATE_RR_N][1 + CRATE_RR_SIZE_MAX_DWORD];
    CRATE_REQUEST rreq[CRATE_RR_N];
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TReadUSBCrateThread(TCrateUSB *_crate, bool CreateSuspended);
    __fastcall ~TReadUSBCrateThread(void);
    };
//---------------------------------------------------------------------------
class TWriteUSBCrateThread : public TThread
    {
private:
    TCrateUSB *crate;
    DWORD dwWriteBuf[CRATE_WR_SIZE_MAX_DWORD];
    CRATE_REQUEST wreq;
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TWriteUSBCrateThread(TCrateUSB *_crate, bool CreateSuspended);
    __fastcall ~TWriteUSBCrateThread(void);
    };
//---------------------------------------------------------------------------
class TIPCratePingThread : public TThread
    {
private:
    TCrateIP *crate;
    HANDLE hTermEvent;
    DWORD ping_timeout;
    int ping_attempts;
protected:
    void __fastcall Execute(void);
public:
    __fastcall TIPCratePingThread(TCrateIP *_crate, bool CreateSuspended, DWORD _timeout, int _attempts);
    __fastcall ~TIPCratePingThread(void);
    void __fastcall TerminateByEvent(void);
    };
//---------------------------------------------------------------------------
class TIPCrateDataThread : public TThread
    {
private:
    TCrateIP *crate;
    BYTE SendBuf[CRATE_IP_SEND_BUF_SIZE];
    BYTE RecvBuf[CRATE_IP_RECV_BUF_SIZE];
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TIPCrateDataThread(TCrateIP *_crate, bool CreateSuspended);
    __fastcall ~TIPCrateDataThread(void);
    };

#endif
